#ifndef LOADERUTILS_HPP
#define LOADERUTILS_HPP

#include <SFML/Graphics/Rect.hpp>
#include <SFML/System/Vector2.hpp>
#include <string>
#include <utility>

class LoaderUtils
{
	public:
		template< typename T >
		struct Parsed
		{
			T data;
			std::string leftover;
		};
		
		static std::pair< std::string, std::string > parseSides( const std::string& str, std::string sep = "=" );
		static Parsed< sf::Vector2i > parseVec2( const std::string& str );
		static Parsed< sf::IntRect > parseRect( const std::string& str );
};

#endif // LOADERUTILS_HPP
