#ifndef AREA_HPP
#define AREA_HPP

#include <memory>
#include <SFML/System/Vector2.hpp>
#include <string>
#include <vector>

#include "Room.hpp"

class Area
{
	public:
		Area( Game& theGame, Player& thePlayer, const std::string& theName, sf::Vector2i theSize );
		
		sf::Vector2i getMinimumRoom() const;
		sf::Vector2i getMaximumRoom() const;
		
		sf::Vector2i getSize() const;
		Room& getRoom( sf::Vector2i room );
		const Room& getRoom( sf::Vector2i room ) const;
		
		Player& getPlayer();
		const Player& getPlayer() const;
		
		Game& getGame();
		const Game& getGame() const;
	
	private:
		Game& game;
		Player& player;
		const std::string name;
		const sf::Vector2i size;
		
		std::vector< std::shared_ptr< Room > > rooms;
};

#endif // AREA_HPP
