#include "game/BombPuzzleEntity.hpp"

#include <SFML/Graphics/Texture.hpp>
#include <util/Logger.hpp>

#include "game/Player.hpp"
#include "game/Room.hpp"

BombPuzzleEntity::BombPuzzleEntity( Room& room, Player& player, sf::Vector2i pos )
   : Entity::Entity( room, player ),
     broken( false )
{
	spr.setPosition( sf::Vector2f( pos ) );
	
	solidIndex = room.getSolids().size();
	room.getSolids().push_back( sf::IntRect( pos.x, pos.y, 6, 1 ) );
}

void BombPuzzleEntity::update()
{
	//
}

void BombPuzzleEntity::render( sf::RenderWindow& window )
{
	if ( !broken )
	{
		Entity::render( window );
	}
}

void BombPuzzleEntity::setTexture( const sf::Texture& tex )
{
	spr.setTexture( tex, true );
	//spr.setOrigin( tex.getSize().x / 2, tex.getSize().y / 2 );
}

void BombPuzzleEntity::breakWall()
{
	broken = true;
	player.playSound( "res/sound/solved.wav" );
	room.getSolids().erase( room.getSolids().begin() + solidIndex );
}
