#ifndef ENEMYENTITY_HPP
#define ENEMYENTITY_HPP

#include <string>

#include "game/Entity.hpp"

namespace sf
{
	class Texture;
}

class EnemyEntity : public Entity
{
	public:
		EnemyEntity( Room& room, Player& player, const std::string& theType, sf::Vector2i pos );

		virtual void update();
		virtual void render( sf::RenderWindow& window );

		virtual sf::FloatRect getCollisionRect();

		std::string getType() const;
		int getHealth() const;
		void setHealth( int theHealth );
		void setStrength( int theStrength );
		void setSpeed( float theSpeed );
		void setTexture( const sf::Texture& tex );

		void hurt( int amt );

		void reset();

	private:
		const std::string type;
		int health;
		int strength;
		float speed;
		int startHealth;
		int stunTime;

		const sf::Vector2i startPos;

		// Boss stuff
		int minionTimer;
		int leafTimer;
		int bombTimer;
};

#endif // ENEMYENTITY_HPP
