#ifndef ENTITY_HPP
#define ENTITY_HPP

#include <SFML/Graphics/Sprite.hpp>

namespace sf
{
	class RenderWindow;
}

class Game;
class Player;
class Room;

class Entity
{
	public:
		Entity( Room& theRoom, Player& thePlayer );
		virtual ~Entity();
		
		virtual void update();
		virtual void render( sf::RenderWindow& window );
		
		virtual sf::Vector2f getPosition() const;
		virtual sf::FloatRect getCollisionRect() const;
		
		void addVelocity( float x, float y );
		void push( float force, float dir );
	
	protected:
		Room& room;
		Player& player;
		sf::Sprite spr;
		sf::Vector2f vel;
};

#endif // ENTITY_HPP
